#include <stdio.h>
#include <propeller.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define P2_TARGET_MHZ 160
#include "sys/p2es_clock.h"

//#include "complex.h"
#include "graphictools.h"

#define IO_BASE   16
#define  ADC  IO_BASE+5
#define  DAC  IO_BASE+6
#define BAUD 230400

#define TRIGGER 498
#define BITLEVEL 111560

void main ()
{
  int adc,dac,x,y;
  float Q0,Q1,Q2,mag,arg;
  int N = 5000;
  float cosine = 0.9971;
  float sine   = 0.0762;
  float coeff  = 1.9942;
  
  clkset(_SETFREQ, _CLOCKFREQ);
  Setup_Video();
  _setbaud(BAUD);
  
  _waitms(100); //wait for Terminal


  pinconfig(ADC, 0b100011_0000000_00_11000_0, 9, 0);   // ADC10bit Ainp
  _waitx(_CLOCKFREQ/100);  
  //dac = 0;
  //pinconfig(DAC, 0b10100_00000000_01_00010_0, 1, dac);  // DAC16bit dither
  //_waitx(_CLOCKFREQ/100);
  clearscreen(WHITE);
  //printf("! now start the wav file\n");
  x = 0; y = 100;
  for(int bits = 1; bits <= 1679; bits ++)
  {
    START:
    adc = _rdpin(ADC);
    if (adc < TRIGGER )
      goto START;

    Q0=0;Q1=0;Q2=0;
    for (int n = 0; n < N; n++)
    {  
      adc = _rdpin(ADC);
      Q0 = coeff * Q1 - Q2 + adc;
      Q2 = Q1;
      Q1 = Q0;
      _waitus(4);
      _pinnot(7); //12.8 us
    }
    float RE = (Q1 - Q2 * cosine);
    float IM = (Q2 * sine);    
    mag=sqrt(RE * RE + IM * IM);
    printf("%d %d\n",bits,(int)mag);
    
    if((int)mag > BITLEVEL)
      plot(300+x,y,BLACK);
    else
      plot(300+x,y,WHITE);
    
    x = x + 1;
    if (x==24)
    {
      x = 1;
      y = y + 1;
    }
    
     
    _waitms(5);
  }
  //printf("finish\n");
  while(1);
}

void pinconfig(int pin, int mode, int x, int y)
{
  _dirl(pin);
  _wrpin(pin,mode);
  _wxpin(pin,x);
  _wypin(pin,y);
  _pinl(pin);
}
